# Create a vertex account

To [create](https://docs.commercelayer.io/core/creating-resources) a new vertex account, send a `POST` request to the `/api/vertex_accounts` endpoint, passing the resource arguments in the request body.

## Request

**POST** <https://yourdomain.commercelayer.io/api/vertex\\_accounts>

### Arguments

| Body Parameter                   | Type      | Required                     |
| -------------------------------- | --------- | ---------------------------- |
| **type**                         | `string`  | Required                     |
| attributes.**name**              | `string`  | Required                     |
| attributes.**reference**         | `string`  | Optional                     |
| attributes.**reference\_origin** | `string`  | Optional                     |
| attributes.**metadata**          | `object`  | Optional                     |
| attributes.**kind**              | `string`  | Optional, default is 'cloud' |
| attributes.**baseurl**           | `string`  | Optional, if cloud           |
| attributes.**client\_id**        | `string`  | Required                     |
| attributes.**client\_secret**    | `string`  | Required                     |
| attributes.**commit\_invoice**   | `boolean` | Optional                     |

### Example

{% tabs %}
{% tab title="Request" %}
The following request creates a new vertex account:

```shell
curl -g -X POST \
  'https://yourdomain.commercelayer.io/api/vertex_accounts' \
  -H 'Accept: application/vnd.api+json' \
  -H 'Authorization: Bearer your-access-token' \
  -H 'Content-Type: application/vnd.api+json' \
  -d '{
  "data": {
    "type": "vertex_accounts",
    "attributes": {
      "name": "Personal tax calculator",
      "client_id": "xxx-yyy-zzz",
      "client_secret": "xxx-yyy-zzz"
    }
  }
}'
```

{% endtab %}

{% tab title="Response" %}
On success, the API responds with a `201 Created` status code, returning the created resource object:

```json
{
  "data": {
    "id": "XAyRWNUzyN",
    "type": "vertex_accounts",
    "links": {
      "self": "https://yourdomain.commercelayer.io/api/vertex_accounts/XAyRWNUzyN"
    },
    "attributes": {
      "name": "Personal tax calculator",
      "type": "avalara_accounts",
      "created_at": "2018-01-01T12:00:00.000Z",
      "updated_at": "2018-01-01T12:00:00.000Z",
      "reference": "ANY-EXTERNAL-REFEFERNCE",
      "reference_origin": "ANY-EXTERNAL-REFEFERNCE-ORIGIN",
      "metadata": {
        "foo": "bar"
      },
      "kind": "cloud",
      "baseurl": "yourbaseurl",
      "api_endpoint": "https://my_baseurl.ondemand.vertexinc.com",
      "commit_invoice": true,
      "token_expires_at": "2018-01-02T12:00:00.000Z"
    },
    "relationships": {
      "markets": {
        "links": {
          "self": "https://yourdomain.commercelayer.io/api/vertex_accounts/XAyRWNUzyN/relationships/markets",
          "related": "https://yourdomain.commercelayer.io/api/vertex_accounts/XAyRWNUzyN/markets"
        }
      },
      "attachments": {
        "links": {
          "self": "https://yourdomain.commercelayer.io/api/vertex_accounts/XAyRWNUzyN/relationships/attachments",
          "related": "https://yourdomain.commercelayer.io/api/vertex_accounts/XAyRWNUzyN/attachments"
        }
      },
      "events": {
        "links": {
          "self": "https://yourdomain.commercelayer.io/api/vertex_accounts/XAyRWNUzyN/relationships/events",
          "related": "https://yourdomain.commercelayer.io/api/vertex_accounts/XAyRWNUzyN/events"
        }
      },
      "versions": {
        "links": {
          "self": "https://yourdomain.commercelayer.io/api/vertex_accounts/XAyRWNUzyN/relationships/versions",
          "related": "https://yourdomain.commercelayer.io/api/vertex_accounts/XAyRWNUzyN/versions"
        }
      },
      "event_stores": {
        "links": {
          "self": "https://yourdomain.commercelayer.io/api/vertex_accounts/XAyRWNUzyN/relationships/event_stores",
          "related": "https://yourdomain.commercelayer.io/api/vertex_accounts/XAyRWNUzyN/event_stores"
        }
      }
    },
    "meta": {
      "mode": "test",
      "organization_id": "xRRkjDFafe",
      "trace_id": "69abaa3545913c78132e5578bd26208d44aa9043647d78698fd0021f3958cd74"
    }
  }
}
```

{% endtab %}
{% endtabs %}


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.commercelayer.io/core-api-reference/vertex_accounts/create.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
